#pragma once
#include "Commons.h"
typedef struct graph Graph;

Graph *buildGraph(int numVertex, int maxNeighbor, int weighting);
void freeGraph(Graph* gr);
int insertEdge(Graph* gr, int source, int dest, double distance, double weight);
RoadSolution Dijkstra(Graph *gr, int source, int dest);
RoadSolution DijkstraOD(Graph *gr, int source, int dest);
RoadSolution DijkstraDial(Graph *gr, int source, int dest);
RoadSolution bellmanford(Graph *gr, int source, int dest);
RoadSolution DEsopoPape(Graph *gr, int source, int dest);
void insertAreaEdge(Graph *gr, Area *ar, Turn *turn, int *PPA, int *inund, Slope *slope);
RoadSolution FillsRoadCompany(int road, int size, Graph *gr, Area *ar, Turn *turn, int *PPA, int *inund, Slope *slope);